/*
 * TREECONTROL creates a tree-like navigation from any nested elements (e.g. UL/LI, OL/LI or DT/DD)
 * Assign an ID to the root element and instantiate a new treeControl.
 *
 * USAGE: var MyTree=new treeControl([rootElementId],[node],[wrapper])
 * That is, for UL/LI: LI is the node, UL is the wrapper.
*/


   treeControl=function(instanceName,treeId,nodeTag,wrapTag) {
      /* properties */
      this.nodeTag=(nodeTag=='' || typeof(nodeTag)=='undefined') ? 'LI':nodeTag;
      this.wrapTag=(wrapTag=='' || typeof(wrapTag)=='undefined') ? 'UL':wrapTag;
      this.root=document.getElementById(treeId);
      this.mainWindow = window.parent.mainWin;
      this.instanceName=instanceName;
      
      this.flip=function(myId) {
         if(document.getElementById(myId).parentNode.innerHTML.indexOf("<ul")==-1 && document.getElementById(myId).parentNode.innerHTML.indexOf("<UL")==-1) { return; }
         thisElement=document.getElementById(myId).parentNode.getElementsByTagName(this.wrapTag);
         if(thisElement[0].style.display=='none') {
            /**
            * add function that parses all child nodes and closes them, unless they're assigned as OPEN.
            **/
            if(typeof(arguments[1])=='undefined') { this.closeChildren(thisElement[0]); }
            thisElement[0].style.display='block';
            document.getElementById(myId).className='treenodeFolderOpen';
            this.addState(myId);
         } else {
            if(typeof(arguments[1])!='undefined' && arguments[1]=='locate') { return true; }
            thisElement[0].style.display='none';
            document.getElementById(myId).className='treenodeFolderClose';
            if(typeof(this.flip.arguments[1])=='undefined') { this.removeState(myId); }
         }
      }
      
      this.closeChildren = function(myId) {
         if(myId.innerHTML.indexOf('<li')==-1 && myId.innerHTML.indexOf('<LI')==-1) { alert("Passed element is type '"+myId.tagName+"'. Need UL!"); return; }
         for(var i=0; i< myId.childNodes.length; i++) {
            if(myId.childNodes[i].tagName=='LI') {
               for(var n=0; n< myId.childNodes[i].childNodes.length; n++) {
                  if(myId.childNodes[i].childNodes[n].tagName=='UL') {
                     myId.childNodes[i].childNodes[n].style.display='none';
                     myId.childNodes[i].childNodes[0].className='treenodeFolderClose';
                  }
               }
            }
         }
      }
      
      this.addState = function(myId) {
         var mySetup=window.top.headerWin.treeState;
         if(mySetup.indexOf(myId)!=-1) { return; }
         else {
            window.top.headerWin.treeState+=myId+';'
         }
      }
      
      this.removeState = function(myId) {
         var mySetup=window.top.headerWin.treeState;
         if(mySetup.indexOf(myId)==-1) { return; }
         else {
            var newSetupChunks=mySetup.split(myId+';');
            window.top.headerWin.treeState=newSetupChunks.join('');
         }
      }
      
      this.loadState = function() {
         var mySetup=window.top.headerWin.treeState;
         var mySetupChunks=mySetup.split(';');
         for(var i=0; i< mySetupChunks.length; i++) {
            if(mySetupChunks[i]!=='') {
               document.getElementById(mySetupChunks[i]).parentNode.getElementsByTagName(this.wrapTag)[0].style.display='block';
               document.getElementById(mySetupChunks[i]).className='treenodeFolderOpen';
               this.closeChildren(document.getElementById(mySetupChunks[i]).parentNode.getElementsByTagName(this.wrapTag)[0]);
            }
         }
      }
      
      this.start = function() {
         this.loading=true;
         if(typeof(window.top.headerWin.treeState)=='undefined') { window.top.headerWin.treeState=''; }
         for(var i=0; i<this.root.childNodes.length;i++) {
            if(this.root.childNodes[i].tagName=='LI') {
               var thisChild=this.root.getElementsByTagName('UL')[0];
               for (var n=0;n<thisChild.childNodes.length; n++) {
                  if(thisChild.childNodes[n].tagName=='LI') {
                     this.flip(thisChild.childNodes[n].childNodes[0].id,true);
                  }
               }
            }
         }
         this.loadState();
         this.loading=false;
      }
   }